diff -u ruby-1.8.4-preview2-org/ ruby-1.8.4-preview2/ 
--- ruby-1.8.4-preview2-org/dir.c	2005-09-14 22:40:58.000000000 +0900
+++ ruby-1.8.4-preview2/dir.c	2005-12-06 23:28:18.000000000 +0900
@@ -922,5 +922,5 @@
 	if (
 #if defined DOSISH
-	    TRUE
+	    !0 /* TRUE */
 #else
 	    !(flags & FNM_NOESCAPE)
--- ruby-1.8.4-preview2-org/io.c	2005-10-24 21:15:26.000000000 +0900
+++ ruby-1.8.4-preview2/io.c	2005-12-19 22:08:34.000000000 +0900
@@ -2776,5 +2776,5 @@
 }
 
-#if defined (_WIN32) || defined(DJGPP) || defined(__CYGWIN__) || defined(__human68k__) || defined(__VMS)
+#if defined (_WIN32) || defined(DJGPP) || defined(__CYGWIN__) || defined(__human68k__) || defined(__VMS) || defined(OS2)
 static struct pipe_list {
     OpenFile *fptr;
@@ -2883,9 +2883,13 @@
     OpenFile *fptr;
 
-#if defined(DJGPP) || defined(__human68k__) || defined(__VMS)
+#if defined(DJGPP) || defined(__human68k__) || defined(__VMS) || (defined(OS2) && !defined(OS2_FORKABLE))
     FILE *f;
 
     if (!pname) pname = StringValuePtr(pstr);
+#if defined(OS2)
+    f = do_os2_popen(pname, mode);
+#else
     f = popen(pname, mode);
+#endif
     
     if (!f) rb_sys_fail(pname);
--- ruby-1.8.4-preview2-org/instruby.rb	2005-07-05 23:45:32.000000000 +0900
+++ ruby-1.8.4-preview2/instruby.rb	2005-12-20 06:03:30.000000000 +0900
@@ -89,4 +89,5 @@
 
 exeext = CONFIG["EXEEXT"]
+batext = (RUBY_PLATFORM =~ /-os2/) ? ".cmd" : ".bat"
 
 ruby_install_name = CONFIG["ruby_install_name"]
@@ -166,5 +167,5 @@
 
   if ruby_bin_dosish
-    batfile = File.join(CONFIG["bindir"], name + ".bat")
+    batfile = File.join(CONFIG["bindir"], name + batext)
     open(with_destdir(batfile), "w") { |b|
       b.print <<EOH, shebang, body, <<EOF
--- ruby-1.8.4-preview2-org/main.c	2004-11-01 01:06:56.000000000 +0900
+++ ruby-1.8.4-preview2/main.c	2005-12-15 03:44:10.000000000 +0900
@@ -41,4 +41,7 @@
     argc = ccommand(&argv);
 #endif
+#if defined(__EMX__) || defined(OS2)
+    _os2ruby_init(); /* should be moved in eval.c... */
+#endif
 
     ruby_init();
--- ruby-1.8.4-preview2-org/process.c	2005-11-20 12:30:46.000000000 +0900
+++ ruby-1.8.4-preview2/process.c	2005-12-13 03:15:06.000000000 +0900
@@ -1266,5 +1266,5 @@
     VALUE obj;
 {
-#if !defined(__human68k__) && !defined(_WIN32) && !defined(__MACOS__) && !defined(__EMX__) && !defined(__VMS)
+#if !defined(__human68k__) && !defined(_WIN32) && !defined(__MACOS__) && !(defined(OS2) && !defined(OS2_FORKABLE)) && !defined(__VMS)
     int pid;
 
--- ruby-1.8.4-preview2-org/missing/os2.c	2004-02-21 11:12:20.000000000 +0900
+++ ruby-1.8.4-preview2/missing/os2.c	2005-12-20 05:42:00.000000000 +0900
@@ -8,8 +8,45 @@
 #include <limits.h>
 #include <errno.h>
+#include <unistd.h>
 
 #define INCL_DOS
 #include <os2.h>
 
+static
+int
+setenvval(const char *n, const char *val)
+{
+    char *s;
+
+    size_t nn, nv;
+    nn = strlen(n);
+    nv = val ? strlen(val) : 0;
+    s = (char *)malloc(nn + 1 + nv + 1);
+    if (!s) return -1;
+    strcpy(s, n);
+    strcat(s, "=");
+    if (val) strcat(s, val);
+    return putenv(s);
+}
+
+void
+_os2ruby_init()
+{
+    char *env_emxshell, *env_shell;
+
+    _mb_cur_max = 2; /* MB_CUR_MAX : minimal kludge for DBCS env. */
+
+    /* set alternative shell for popen() and system(). */
+    env_emxshell = getenv("EMXSHELL");
+    env_shell = getenv("RUBYSHELL");
+    if (env_shell) {
+        setenvval("EMXSHELL", env_shell);
+    }
+    else if (!env_emxshell) {
+        env_shell = getenv("SHELL");
+        if (env_shell) setenvval("EMXSHELL", env_shell);
+    }
+}
+
 int
 chown(char *path, int owner, int group)
@@ -24,6 +61,186 @@
 }
 
+#if defined(EMX_REPLACE_GETCWD) && (EMX_REPLACE_GETCWD)
+char *
+getcwd(char *path, size_t len)
+{
+    return _getcwd2(path, (int)len);
+}
+#endif
+
+#if defined(EMX_REPLACE_CHDIR) && (EMX_REPLACE_CHDIR)
+int
+chdir(const char *path)
+{
+    return _chdir2(path);
+}
+#endif
+
 typedef char* CHARP;
 
+static
+char *
+_get_default_shell(is_unixish)
+int *is_unixish;
+{
+#if defined(DOS) || defined(MSDOS)
+    static char defaultShell[] = "\\command.com";
+#else
+    static char defaultShell[] = "cmd.exe";
+#endif
+    char *shell, *sn;
+
+    shell = getenv("RUBYSHELL");
+#if 0
+    if (!shell || (shell && *shell == '\0')) shell = getenv("SHELL");
+#endif
+#if defined(__EMX__)
+    if (!shell || (shell && *shell == '\0')) shell = getenv("EMXSHELL");
+#endif
+    if (!shell || (shell && *shell == '\0')) shell = getenv("COMSPEC");
+    if (!shell || ((sn = _getname(shell)) == NULL || *sn == '\0'))
+        shell = sn = defaultShell;
+    
+    if (is_unixish) {
+        *is_unixish = !(stricmp(sn, "cmd.exe") == 0 || 
+                        stricmp(sn, "cmd") == 0 ||
+#if defined(DOS) || defined(MSDOS)
+                        stricmp(sn, "command.com") == 0 ||
+                        stricmp(sn, "command") == 0 ||
+#elif defined(OS2) || defined(__OS2__)
+                        stricmp(sn, "4os2.exe") == 0 ||
+                        stricmp(sn, "4os2") == 0
+#endif
+                       );
+    }
+    
+    return shell;
+}
+
+FILE *
+do_os2_popen(cmd, mode)
+const char *cmd;
+const char *mode;
+{
+    FILE *fp;
+    char c, *cmd2;
+    int is_sh;
+    size_t i, len;
+    
+    if (!cmd) return NULL;
+    len = strlen(cmd);
+    cmd2 = ALLOC_N(char, len + 1);
+    strcpy(cmd2, cmd);
+    _get_default_shell(&is_sh);
+    if (!is_sh) for(i=0; i<len; i++) {
+        c = cmd2[i];
+        if (c == '\0' || c == ' ' || c == '\t' || c == '\n') break;
+        if (c == '/') cmd2[i] = '\\';
+    }
+#if 0
+    fprintf(stderr, "popen(\"%s\", \"%s\")\n", cmd2, mode);
+#endif
+    fp = popen(cmd2, mode);
+    free(cmd2);
+    return fp;
+}
+
+int
+do_os2_system(cmd)
+const char *cmd;
+{
+    int status;
+    char c, *cmd2;
+    int is_sh;
+    size_t i, len;
+    
+    if (!cmd) return system(cmd);
+    
+    len = strlen(cmd);
+    cmd2 = ALLOC_N(char, len + 1);
+    strcpy(cmd2, cmd);
+    _get_default_shell(&is_sh);
+    if (!is_sh) for(i=0; i<len; i++) {
+        c = cmd2[i];
+        if (c == '\0' || c == ' ' || c == '\t' || c == '\n') break;
+        if (c == '/') cmd2[i] = '\\';
+    }
+#if 0
+    fprintf(stderr, "system(\"%s\")\n", cmd2);
+#endif
+    status = system(cmd2);
+    free(cmd2);
+    
+    return status;
+}
+
+#if 1
+int
+do_spawn(cmd)
+char *cmd;
+{
+    register char **a;
+    register char *s;
+    char **argv;
+    char *shell, *sw, *metachars, *cmd2;
+    int is_sh;
+    int status;
+
+    shell = _get_default_shell(&is_sh);
+    if (is_sh) {
+        sw = "-c";
+        metachars = "$&*(){}[]'\";\\|?<>~`\n";
+    } else {
+        sw = "/c";
+        metachars = "^()<>|&\n";
+    }
+    
+    /* see if there are shell metacharacters in it */
+    /*SUPPRESS 530*/
+    /*    for (s = cmd; *s && isalpha(*s); s++) ;
+    if (*s == '=')
+    goto doshell; */
+    for (s = cmd; *s; s++) {
+        if (*s != ' ' /* && !isalpha(*s) */ && index(metachars, *s)) {
+            if (*s == '\n' && !s[1]) {
+                *s = '\0';
+                break;
+            }
+	  doshell:
+#if 0
+            status = do_os2_system(cmd);
+#else
+            status = spawnlp(P_WAIT,shell,shell,sw,cmd,(char*)NULL);
+#endif
+            return status;
+        }
+    }
+    argv = ALLOC_N(CHARP,(strlen(cmd) / 2 + 2));
+    cmd2 = ALLOC_N(char, (strlen(cmd) + 1));
+    strcpy(cmd2, cmd);
+    a = argv;
+    for (s = cmd2; *s;) {
+	while (*s && isspace(*s)) s++;
+	if (*s)
+	    *(a++) = s;
+	while (*s && !isspace(*s)) s++;
+	if (*s)
+	    *s++ = '\0';
+    }
+    *a = NULL;
+    if (argv[0]) {
+        if ((status = spawnvp(P_WAIT, argv[0], argv)) == -1) {
+            free(argv);
+            free(cmd2);
+            return -1;
+        }
+    }
+    free(cmd2);
+    free(argv);
+    return status;
+}
+
+#else
+
 int
 do_spawn(cmd)
@@ -112,2 +329,3 @@
     return status;
 }
+#endif
--- ruby-1.8.4-preview2-org/ext/curses/curses.c	2005-08-27 20:21:30.000000000 +0900
+++ ruby-1.8.4-preview2/ext/curses/curses.c	2005-12-06 23:56:42.000000000 +0900
@@ -44,4 +44,7 @@
 #  endif
 # endif
+# if defined(__EMX__)
+  typedef int chtype;
+# endif
 #endif
 
--- ruby-1.8.4-preview2-org/ext/openssl/ossl.h	2005-06-20 01:29:16.000000000 +0900
+++ ruby-1.8.4-preview2/ext/openssl/ossl.h	2005-12-07 00:22:18.000000000 +0900
@@ -31,4 +31,6 @@
 #if defined(_WIN32)
 #  define OpenFile WINAPI_OpenFile
+#endif
+#if defined(_WIN32) || defined(OS2)
 #  define OSSL_NO_CONF_API 1
 #endif
--- ruby-1.8.4-preview2-org/ext/socket/extconf.rb	2005-07-20 04:04:46.000000000 +0900
+++ ruby-1.8.4-preview2/ext/socket/extconf.rb	2005-12-15 02:56:22.000000000 +0900
@@ -14,5 +14,5 @@
   have_library("net", "socket")
   have_func("closesocket")
-when /i386-os2_emx/
+when /os2-emx/
   test_func = "socket"
   have_library("socket", "socket")
--- ruby-1.8.4-preview2-org/test/fileutils/test_fileutils.rb	2005-09-19 10:37:28.000000000 +0900
+++ ruby-1.8.4-preview2/test/fileutils/test_fileutils.rb	2005-12-15 04:08:54.000000000 +0900
@@ -106,4 +106,5 @@
   def teardown
     tmproot = Dir.pwd
+    Dir.chdir Dir.tmpdir
     Dir.chdir @prevdir
     my_rm_rf tmproot
--- ruby-1.8.4-preview2-org/test/fileutils/test_nowrite.rb	2005-09-24 08:39:00.000000000 +0900
+++ ruby-1.8.4-preview2/test/fileutils/test_nowrite.rb	2005-12-15 04:09:36.000000000 +0900
@@ -49,4 +49,5 @@
   def teardown
     tmproot = Dir.pwd
+    Dir.chdir Dir.tmpdir
     Dir.chdir @prevdir
     my_rm_rf tmproot
